jQuery(function ($) {
    var canceled = false;
    $.validator.setDefaults({
        ignore: []
    });


    $('#columnnamesubmit').on('click', function () {
        var fields = $("#page_generation_grid").jsGrid("option", "fields");
        var columnTitle = $('#columnname').val();
        fields.splice(fields.length - 1, 0, {"type": "text", "name": columnTitle})
        $("#page_generation_grid").jsGrid("option", "fields", fields)
    })
    $('#accept').on('click', function () {
        canceled = false;
        $.toggleRotating($('#accept'), true);
        var data = $("#page_generation_grid").jsGrid("option", "data");

        createPage(data, 0)
    })

    function createPage(data, index) {
        if (canceled) {
            return false;
        }

        let element = data[index];

        let filtered_element = {};
        for (const [key, value] of Object.entries(element)) {
            let filtered_key = String(key).replace(/(\r\n|\n|\r)/gm, "");
            let filtered_value = String(value).replace(/(\r\n|\n|\r)/gm, "");
            filtered_element[filtered_key] = filtered_value;
        }
        let jsonString = JSON.stringify(filtered_element);

        var ajaxData = {
            "action": 'lpagery_generate_posts',
            "data": jsonString,
            "categories": $('#categories').val(),
            "templatePath": $('#template_path').val(),
            "parent_path": $('#parent_path').val(),
            "slug": $('#slug').val(),
            "status": $('#post_status').val(),
            "_ajax_nonce": lpagery_ajax_object_modal.nonce
        };

        jQuery.ajax({
            "method": "post",
            "url": lpagery_ajax_object_modal.ajax_url,
            "data": ajaxData,
            "error" : function (response) {
                console.error(response)
                console.error(response.responseText)
                onError(response.responseText);
            },
            "success": function (response) {
                $('#pagestatus').html("Generated <b>" + index + "</b> of <b>" + data.length + "</b> Pages")
                if (index === (data.length - 1)) {
                    uploadFinished()
                    var ajaxDataPostType = {
                        "action": 'lpagery_get_post_type',
                        "post_id": $('#template_path').val(),
                        "_ajax_nonce": lpagery_ajax_object_modal.nonce
                    };
                    jQuery.ajax({
                        "method": "get",
                        "url": lpagery_ajax_object_modal.ajax_url,
                        "data": ajaxDataPostType,
                        "success": function (response) {
                            $('#generated_page_link').prop('href', 'edit.php?post_type=' + response + '&orderby=date&order=desc')
                        }
                    });
                    return;
                }

                try {
                    let parsed = JSON.parse(response)
                    if (!parsed.success) {
                        console.error(parsed.exception)
                        onError(parsed.exception);
                    }
                } catch (e) {
                    console.error(e)
                    console.error(response)
                    onError(e, response);
                }


                createPage(data, ++index);
            }
        })


    }


    function uploadFinished() {
        finished = true;
        $('#pagestatus').hide()
        $('#error-area').hide();
        $.toggleRotating($('#accept'), false);
        jQuery('#fadeout').fadeTo(700, 0.2);
        $(".check-center").hide();
        $('.check-center').show();
        jQuery('#fadeout').css({pointerEvents: "none"})
    }

    $('#closeModal a').on('click', function () {
        $.modal.close();
    });

    $('#cancel').on('click', function (e) {
        canceled = true;
        $.modal.close();
    })

    $.getHeaders = function getHeaders(headers) {
        return headers.map(value => {
            return {
                "name": value,
                "type": "text"
            }
        });
    }


    $.toggleRotating = function toggleRotating(element, rotate) {
        if (rotate) {
            element.addClass('button--loading').prop("disabled", true);
        } else {
            element.removeClass('button--loading').prop("disabled", false);
        }
    }

    $.toggleEnabled = function toggleEnabled(element, enabled) {
        element.prop("disabled", !enabled);
    }

    $.showModal = function showModal(headersFields, data) {
        jQuery('#fadeout').css({pointerEvents: ""})

        $('#error-area').hide();
        $('#pagestatus').html('');
        $('#pagestatus').show()

        $(".check-center").hide();
        $('#fadeout').css('opacity', '')
        $.toggleRotating($('#next'), false)
        $.toggleRotating($('#accept'), false)

        if (!lpagery_ajax_object_modal.is_free_plan) {
            headersFields.push({type: "control"});
        }

        $("#page_generation_grid").jsGrid({
            width: "100%",
            height: "400px",

            inserting: !lpagery_ajax_object_modal.is_free_plan,
            editing: !lpagery_ajax_object_modal.is_free_plan,
            sorting: true,
            paging: false,
            selecting: true,
            confirmDeleting: false,
            data: data,

            fields: headersFields
        });


        $('#confirmModal').modal({
            escapeClose: false,
            clickClose: false,
            showClose: false
        });
        // hier walkthrough
        var lpageryIntroShowed = localStorage.getItem('lpagery_modal_intro_showed');
        if (!lpageryIntroShowed && window.location.href.includes("lpagery")) {
            introJs().setOptions({
                disableInteraction: true,
                showProgress: true,
                showBullets: false,

                steps: [{
                    element: document.querySelector('#page_generation_grid'),
                    title: 'Check all pages that will be generated',
                    intro: 'Every row represents one generated page. In the first row you can see all placeholders that are generated and can be used on your page',
                    position: 'bottom',

                },

                    {

                        element: document.querySelector('#accept'),
                        title: 'Generate the pages',
                        intro: 'When you are done with any adjustments, click the button and all pages will be generated',
                        position: 'bottom',

                    }

                ]
            }).start();
            localStorage.setItem('lpagery_modal_intro_showed', true);
        }
    }

    function onError(...errors) {
        $('#pagestatus').hide();
        $('#error-area').show();
        $.toggleRotating($('#accept'), false);
        canceled = true;
        console.log(errors)
        let errorsString = errors.map(s => '\n' + s).toString();
        $('#error-content').html(errorsString)


    }


})