<?php


require_once( plugin_dir_path( __FILE__ ) . 'MetaDataHandler.php' );
require_once( plugin_dir_path( __FILE__ ) . 'SubstitutionHandler.php' );
require_once( plugin_dir_path( __FILE__ ) . 'PagebuilderHandler.php' );


class LPageryPageCreator {

	public static function lpagery_create_substituted_page( $keys, $values, WP_Post $post, $parentId, $categories, $slug, $status ) {
		$replaced          = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $post->post_content );
		$replaced_filtered = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $post->post_content_filtered );
		$replaced_title    = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $post->post_title );
		$replaced_slug     = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $slug );
		$replaced_excerpt  = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $post->post_excerpt );


		$new_post = [
			'post_content'          => $replaced,
			'post_content_filtered' => $replaced_filtered,
			'post_title'            => $replaced_title,
			'post_excerpt'          => $replaced_excerpt,
			'post_type'             => $post->post_type,
			'comment_status'        => $post->comment_status,
			'ping_status'           => $post->ping_status,
			'post_password'         => $post->post_password,
			'post_name'             => $replaced_slug != null ? $replaced_slug : null,
			'post_parent'           => $parentId != null ? $parentId : null,
			'post_mime_type'        => $post->post_mime_type,
			'post_status'           => $status
		];
		$post_id  = wp_insert_post( $new_post );
		wp_set_post_categories( $post_id, $categories );
		LPageryMetaDataHandler::lpagery_copy_post_meta_info( $post_id, $post, array( "_lpagery_page_source" ), $keys, $values );
		LPageryPagebuilderHandler::lpagery_handle_pagebuilder( $post->ID, $post_id, $keys, $values );
	}

}