<?php

require_once "SubstitutionHandler.php";
class LPageryPagebuilderHandler {
	public static function lpagery_handle_pagebuilder( $sourcePostId, $targetPostId, $keys, $values) {
		$post_meta_keys = get_post_custom_keys( $sourcePostId );
		if ( in_array( '_elementor_version', $post_meta_keys ) ) {
			self::lpagery_handle_elementor( $sourcePostId, $targetPostId );
		}
		if ( in_array( 'brizy', $post_meta_keys ) ) {
			self::lpagery_handle_brizy( $sourcePostId, $targetPostId , $keys, $values);
		}
	}

	/**
	 * @param $source_post_id
	 * @param $target_post_id
	 *
	 * @return void
	 */
	private static function lpagery_handle_elementor( $source_post_id, $target_post_id ) {
		$elementor_css_path = WP_CONTENT_DIR . "/uploads/elementor/css/";
		$source_path       = $elementor_css_path . "post-" . $source_post_id . ".css";
		$css_content       = file_get_contents( $source_path );

		$css_content = str_replace( ".elementor-" . $source_post_id, ".elementor-" . $target_post_id, $css_content );
		file_put_contents( $elementor_css_path . "post-" . $target_post_id . ".css", $css_content );
	}

	private static function lpagery_handle_brizy( $source_post_id, $target_post_id, $keys, $values ) {
		$meta_values = get_post_custom_values( "brizy", $source_post_id);
		foreach ($meta_values as $meta_value) {
			$deserialized = maybe_unserialize( $meta_value );
			$plain_html = base64_decode( $deserialized['brizy-post']['compiled_html'] );
			$substituted_html   = LPagerySubstitutionHandler::lpagery_substitute( $keys, $values, $plain_html );
			$html_base64 = base64_encode( $substituted_html );
			$deserialized['brizy-post']['compiled_html'] = $html_base64;
			delete_post_meta( $target_post_id, "brizy" );

			add_post_meta( $target_post_id, "brizy", LPageryUtils::lpagery_recursively_slash_strings( $deserialized ) );
			echo $plain_html;
		}


	}
}