<?php

class LPagerySubstitutionHandler
{
    public static function lpagery_substitute( $keys, $values, $content )
    {
        
        if ( is_object( $content ) ) {
            $content = (object) self::lpagery_substituteArray( $keys, $values, (array) $content );
        } elseif ( is_array( $content ) ) {
            $content = self::lpagery_substituteArray( $keys, $values, (array) $content );
        } else {
            $content = str_ireplace( $keys, $values, $content );
            if ( lpagery_fs()->can_use_premium_code__premium_only() && lpagery_fs()->is_plan( "extended" ) ) {
                if ( LPagerySettingsController::lpagery_get_spintax_enabled() !== false ) {
                    
                    if ( strpos( $content, '|' ) !== false ) {
                        $spintax = new LPagerySpintax();
                        $content = $spintax->lpagery_process( $content );
                    }
                
                }
            }
        }
        
        return $content;
    }
    
    public static function lpagery_substituteArray( $keys, $values, $array )
    {
        array_walk_recursive( $array, function ( &$value, $key ) use( $keys, $values ) {
            $value = self::lpagery_substitute( $keys, $values, $value );
        } );
        return $array;
    }

}