<!-- Form to handle the upload - The enctype value here is very important -->


<div class="Main" data-title="Welcome to LPagery">
    <h2>Generate Landing Pages</h2>
    <form method="post" id="lpageryform" enctype="multipart/form-data">
        <div id="template-section">
            <div class="template-path-section">

                <label for="template_path" class="select-label">1. Select Template Page*
                    <div class="tooltip">?
                        <span class="tooltiptext">Need help to set up your Template Page? <a
                                    href="https://lpagery.io/docs/create-a-template-page/">Click here</a></span>
                    </div>
                </label>


                <select class="js-example-basic-single page-select" name="template_path" id="template_path"
                        style="margin-bottom: 20px" required>
                    <option value="">
						<?php 
echo  esc_attr( __( 'Select page' ) ) ;
?></option>
                </select><br>
                <span id="template_error"></span>
            </div>
        </div>
        <div id="parent-section" class="license-needed" license="extended">
            <label for="parent_path" class="select-label">2. Select Parent Page <span class="optional">(optional)</span>
                <div class="tooltip">?
                    <span class="tooltiptext">This will add a parent page to the generated pages and also will add the URI of the parent page to the URI of the generated pages.</span>
                </div>
            </label>


            <select class="js-example-basic-single page-select" name="parent_path" id="parent_path"
                    style="margin-bottom: 20px">
                <option value="">
					<?php 
echo  esc_attr( __( 'Select page' ) ) ;
?></option>

            </select><br>
        </div>

        <div license="extended" id="slug-section" class="license-needed">
            <label for="slug" class="select-label">3. Set URI slug
                <div class="tooltip">?
                    <span class="tooltiptext">Slashes will be added according to your permalink settings. For more on this check out our tutorial on slugs: <a
                                href="https://lpagery.io/docs/edit-the-permalink-structure-of-the-generated-pages/">Click here</a></span>
                </div>
            </label>

            <input type="text" class="labels" id="slug" name="slug" size="25"
                   placeholder="e.g. my-cool-page-in-{city}" required>
            <span id="slug_disabled" hidden>The URI will be ignored if the permalink structure of your site is set to "plain".</span>
            <span id="slug_preview"></span>
        </div>


        <div license="extended" id="category-section" class="license-needed">
            <label for="categories" class="select-label">4. Select Categories <span class="optional">(optional)</span>

            </label>


            <select class="js-example-basic-multiple" name="categories" id="categories"
                    style="margin-bottom: 20px" multiple="multiple">
				<?php 
$categories = get_categories( array(
    'hide_empty' => false,
    'orderby'    => 'name',
    'order'      => 'ASC',
) );
$allowed_html = array(
    'option' => array(
    'value' => array(),
),
);
foreach ( $categories as $category ) {
    $option = '<option value="' . esc_html( $category->term_id ) . '">';
    $option .= esc_html( $category->name );
    $option .= '</option>';
    echo  wp_kses( $option, $allowed_html ) ;
}
?>
            </select><br>

        </div>

        <div license="extended" id="status-section" class="license-needed">
            <label for="post_status" class="select-label">5. Select Page Status
                <div class="tooltip">?
                    <span class="tooltiptext">Specify which status the generated pages should have</span>
                </div>
            </label>


            <select name="post_status" id="post_status">
                <option value="publish" selected>
                    Published
                </option>
                <option value="draft">
                    Draft
                </option>
                <option value="private">
                    Private
                </option>
            </select><br>
        </div>

        <div id="modeRadio">
            <div id="radio-buttons" license="standard" class="license-needed">
                <h3 id="input-heading">
                    6. What input do you want to use?
                </h3>
                <div class="input-type-wrapper">
                    <div id="csv">
                        <input type="radio" id="modeCsv" name="modeRadio" checked="checked"
                               value="csv"/>CSV / XLSX
                    </div>
                    <div id="radius">
                        <input type="radio" id="modeRadius" name="modeRadio" value="location"/> Radius
                    </div>
                    <div id="googlesheet">
                        <input type="radio" id="modeGoogleSheet" name="modeRadio" value="googlesheet"/> Google Sheet
                    </div>
                </div>
            </div>


            <div id="modecsv" class="desc">
                <div class="row">
                    <div class="column-left">

                        <input class="csv_input" type='file' id="upload_csv" name='upload_csv'></div>
                    <br>
                    <br>

                    <div id="drop_zone" ondrop="dropHandler(event);" ondragover="dragOverHandler(event);">
                        <p>Drag one or more files to this Drop Zone ...</p>
                    </div>
                </div>
            </div>
			<?php 
?>
            <input type="hidden" id="lat" name="lat" required><br>
            <input type="hidden" id="lng" name="lng"><br>
            <input type="hidden" id="substitution_data" name="substitution_data">
            <input type="hidden" id="categories_txt" name="categories_txt">

            <div id="lpagery-next-button">
                <button type="button" value="Next" class="lpagery-button" name="next" id="next">
                    <span class="button__text">Next</span>
                </button>
            </div>


            <span hidden id="error_span">An error occured.</span>
        </div>
    </form>
</div>


